import { useEffect, useState } from "react";
import Header from "./Header";
import Tasks from "./Tasks";
import Form from "./Form";
import Footer from "./Footer";
import About from "./About";
import { BrowserRouter as Router, Route, Routes } from "react-router-dom";

function App() {
  const [task, setTask] = useState([]);
  const [showAddTask, setShowAddTask] = useState(false);
  const [editTodo, setEditTodo] = useState(null);
  const [isedit, setIsEdit] = useState(false);


  const deleteTask = async (id) => {
    await fetch(`http://192.168.1.91:5000/task/${id}`, { method: "DELETE" });
    setTask(task.filter((e) => e.id !== id));
  };
  const remainder = async (id) => {
    const toogle = await getTaskById(id);
    const result = { ...toogle, remainder: !toogle.remainder };


    const res = await fetch(`http://192.168.1.91:5000/task/${id}`, {
      method: "PUT",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(result),
    });
    const data = await res.json();
    setTask(
      task.map((e) => (e.id === id ? { ...e, remainder: data.remainder } : e))
    );
  };
  const addTask = async (data) => {
    const res = await fetch(`http://192.168.1.91:5000/task`, {
      method: "POST",
      headers: { "Content-type": "application/json" },
      body: JSON.stringify(data),
    });
    const result = await res.json();
    setTask([...task, result]);
  };

  const getTask = async () => {
    const tasktracker = await fetch("http://192.168.1.91:5000/task");
    const response = await tasktracker.json();
    setTask(response);
  };

  const getTaskById = async (id) => {
    const tasktracker = await fetch(`http://192.168.1.91:5000/task/${id}`);
    const response = await tasktracker.json();
    return response;
  };
  const editTask = async (id) => {
    console.log("dskdn")
    const res = await getTaskById(id);
    if(res){
      setEditTodo(res);
      setIsEdit(true);
      setShowAddTask(true);
    }
   
  };

  const editTodoTask = async (datas) => {
    const response = await fetch(
      `http://192.168.1.91:5000/task/${editTodo.id}`,
      {
        method: "PUT",
        headers: { "Content-type": "application/json" },
        body: JSON.stringify(datas),
      }
    );
    const data = await response.json();

    setTask(task.map((e) => (e.id === data.id ? data : e)));
 
  };


  useEffect(() => {
    getTask();
  }, []);
  return (
    // <> default it takes root id as div
    //passing the values from parent to child using props
    <Router>
      <div className="container">
        <Header
          addtask={() => {setShowAddTask(!showAddTask);setIsEdit(false)}}
          showAdd={showAddTask}
   
        />

        <Routes>
          <Route
            path="/"
            exact
            element={
              <>
                
                  <Form
                    addtask={addTask}
                    onEdit={editTodoTask}
                    onEditData={editTodo}
                    iseditTask={isedit}
                    isAddClose={showAddTask}
                  />
                
                {task.length > 0 ? (
                  <Tasks
                    task={task}
                    ondelete={deleteTask}
                    onEdit={editTask}
                    toggle={remainder}
                    addtask={addTask}
                  />
                ) : (
                  <h3>No Tasks </h3>
                )}
              </>
            }
          ></Route>

          <Route exact path="/about" element={<About/>} />
        </Routes>

        <Footer />
      </div>
    </Router>
  );
}

export default App;
